#! /bin/sh 
#---------------------------------------------------
#shell script to deliver local mail, this shell
#script is called by clement (modtrt.c/dotransit).
#It can be used to fine tune delivery process
#$1 is email file name
#$2 is originator Email
#$3 is recipient Email
#---------------------------------------------------
#defining what is the Local Delivery Agent
LDA=dovecot
#---------------------------------------------------
. `dirname $0`/version.sh

#---------------------------------------------------
#procedure to create dir and set proper mode and ownership
#if directory is missing
#$1 is the directory name
setdir()

{
if [ ! -d $1 ] ; then
  mkdir -p $1
  chmod 755 $1
  USER=`id -nu`
  if [ "$USER" = "root" ] ; then
    chown -R $APPNAME.mail $1
    fi
  fi
}
 
#---------------------------------------------------
#main program
status=127	#lets say trouble first
case "$LDA" in
  "dovecot"	)
    #do we have dovecot-2.0
    if [ ! -d /etc/dovecot ] ; then	
      domdir=$BASE/var/spool/$APPNAME-$VERS/mails/`echo $3 | cut -d'@' -f2`
      usrdir=`echo $3 | cut -d'@' -f1`
      setdir $domdir
      setdir $domdir/$usrdir
      fi
    DOVCONF=$BASE/etc/$APPNAME-$VERS/dovecot.conf
    if [ -x `dirname $0`/chkdovconf.sh ] ; then
      cd `dirname $0`
      usrdom=`echo $3 | cut -d'@' -f2`
      export DOVCONF=`./chkdovconf.sh $usrdom`
      fi
    DOVDEL="/usr/libexec/dovecot/deliver"
    if [ -x $DOVDEL ] ; then
      $DOVDEL -c $DOVCONF -f $2 -d $3 -e < $1 2> /dev/null
      status=$?
      fi
    ;;
  "" | "*"	)	#No or unknown LDA defined!
    ;;
  esac
#---------------------------------------------------
exit $status
