#! /bin/sh
#--------------------------------------------------------------------------
#program to demonstrate email piping capabilities.
#mail is received via STDIN
#--------------------------------------------------------------------------
#taking all variables
. `dirname $0`/version.sh

#Advice email message piped on STDIN and store in TMP
MSG=$BASE/tmp/`basename $0`.$$

#setting the BASE option (test mode)
if [ -n "$BASE" ] ; then
  CLMOPT="-b $BASE"
  fi
#setting the SMPTPORT option (test mode)
if [ -z "SMTPPORT" ] ; then
  SMTPPORT="25"
  fi

#setting the destination email.
DEST=root@`dnsdomainname`
status=0
#--------------------------------------------------------------------------
#storing the message file.
cat - > $MSG

#--------------------------------------------------------------------------
#modifying subject (just an example)
sed -i -e"s/^Subject: /Subject: A Pipe Example: /" $MSG
#--------------------------------------------------------------------------
#sending messages to DEST
cat $MSG | $BASE/usr/bin/clmailc $CLMOPT -F $DEST -H localhost.localdomain:$SMTPPORT $DEST
status=$?

#--------------------------------------------------------------------------
#removing message file
rm $MSG
return $status


