#! /bin/sh
#--------------------------------------------------------------------------
#program to demonstrate email piping capabilities.
#mail is received via STDIN
#--------------------------------------------------------------------------
#taking all variables
. `dirname $0`/version.sh

#setting the return status
status=0

#Advice email message piped on STDIN and store in TMP
MSG=$BASE/tmp/`basename $0`.$$
MSG_s=$BASE/tmp/`basename $0`_s.$$

#setting the BASE option (test mode)
if [ -n "$BASE" ] ; then
  CLMOPT="-b $BASE"
  fi

#setting the SMPTPORT option (test mode)
if [ -z "$SMTPPORT" ] ; then
  SMTPPORT="25"
  fi

#setting the domainname option (test mode)
if [ -z "$fromdomain" ] ; then 
   fromdomain=`dnsdomainname`
   fi
EFROM=no_reply@$fromdomain

#--------------------------------------------------------------------------
#storing the message file.
cat - > $MSG
#--------------------------------------------------------------------------
#extracting session Info.
#CAUTION:	localhost.localdomain MUST be defined with clement.conf 
#		as a site alias
SESSION=`grep 'X-Clement-ID:' $MSG | cut -d':' -f2 | cut -d'<' -f2 | cut -d'>' -f1`
wget -q --no-check-certificate -O $MSG_s https://localhost.localdomain/detail/detail.php?sess=$SESSION,EST5EDT
#--------------------------------------------------------------------------


#setting the destination email.
FROM="Automatic rebounce <$EFROM>"
TO=`grep 'MAIL FROM:' $MSG_s | cut -d':' -f2 | cut -d'<' -f2 | cut -d'>' -f1`
if [ -z "$TO" ] ; then
  TO=`grep '^From:' $MSG | cut -d':' -f2 | cut -d'<' -f2 | cut -d'>' -f1`
  fi
#--------------------------------------------------------------------------
if [ -n "$TO" ] ; then
#extracting subject line
  SUBJ=`grep '^Subject:' $MSG | cut -d':' -f2-`
#modifying subject (just an example)
  sed -i -e"s/^Subject: /Subject: SMTP data: /" $MSG
  sed -i -e"s/^From: .*/From: $FROM/" $MSG
  sed -i -e"s/^To: .*/To: $TO/" $MSG
  HEAD=`grep -n '^$' $MSG | head -1 | cut -d ':' -f1`
#--------------------------------------------------------------------------
#sending messages to DEST, no $TO for now
  (
  head -$HEAD $MSG | sed -e '/^Content/,+1d'
  echo 
  cat $MSG_s
  echo 
  echo "--------------------------------------------"
  echo "Data extracted from SAFE Clement SMTP daemon"
  echo "http://www.clement.safe.ca"
  echo "--------------------------------------------"
  echo 
  ) | $BASE/usr/bin/clmailc $CLMOPT -F $EFROM -H localhost.localdomain:$SMTPPORT $TO
  status=$?
  fi

#--------------------------------------------------------------------------
#removing message file
rm $MSG_s
rm $MSG
exit $status

