#! /bin/sh
#-------------------------------------------------------------
#procedure to send everyone who are over $PERCENTMAX % of their quota. Default at 90%.
#-------------------------------------------------------------
#local variable
#Maximum number of days before the expiration
NBDAY=7
#-------------------------------------------------------------
#setting the basic definition
. `dirname $0`/../shell/version.sh
#-----------------------------------------------------
#loading the variable value
. $BASE/etc/$APPNAME-$VERSION/$APPNAME.conf
#-----------------------------------------------------

clmsndr="$BASE/usr/bin/clmsndr"
clmsndrBase=$clmsndr
if [ -n "$BASE" ] ; then
  clmsndrBase=$clmsndr" -b $BASE"
  fi
Error='0'
LoggerApp="logger -t clmsndr"


#setting the Variable
#first the Data-base type
if [ -z "$DB_TYPE" ] ; then
  DB_TYPE=POSTGRESQL;
  fi

#Then the data-base name
if [ -z "$DB_NAME" ] ; then
  DB_NAME=$APPNAME;
  fi

#-------------------------------------------------------------
case "$DB_TYPE" in
  "POSTGRESQL"  )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-p $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  "MYSQL"       )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-P $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  esac

#----------------------------------------------
#procedure to probe data-base qith an SQL request
#as $1 parametere
prob_db()

{
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "$1" | psql -t -q  -A -F ' ' $SQLPORT $SQLHOST $DB_NAME
     ;;
  "MYSQL"       )
     echo "$1" | mysql -s -u $APPNAME $SQLPORT $SQLHOST $DB_NAME
     ;;
  esac
}

#---------------------------------------------------------
#Check the user prfid in order to determine it language.
langCheck()
{
#$1 username
case "$DB_TYPE" in
  "POSTGRESQL"  )
  spe_user=`echo $1 | sed -e "s/'/''/" `
     ;;
  "MYSQL"       )
  spe_user=`echo $1 | sed -e  's/'\''/\\\\'\''/'`
     ;;
  esac
prfid=`prob_db "SELECT prfid FROM users WHERE username='$spe_user';"`
if [ ! -z "$prfid" ] ; then
lang=`prob_db "SELECT lang FROM userprofile WHERE prfid='$prfid';"`
fi
case "$lang" in
  2	)
    . $BASE/etc/$APPNAME-$VERS/report_francais.conf
    ;;
  1	|							\
  *	)
	. $BASE/etc/$APPNAME-$VERS/report_english.conf
    ;;
  esac
}
#transmet
#print mail to be send to one user.
#$1 'to' clement recipient

#----------------------------------------------


transmet ()

{
cat | $clmsndrBase $1 $2 -m "$FROM"

RETVAL=$?
Error=1
        whoError="while trying to mail $username for QUOTA (Status $RETVAL)(clement sender)"
        case "$RETVAL" in
        0)
       		Error=0
	 ;;
        1)
                $LoggerApp "Unable to get local email $whoError"
        ;;
        2)
                $LoggerApp "Unable to contact remote server $whoError"
        ;;
        3)
                $LoggerApp "Originator is not accepted by remote $whoError"
        ;;
        4)
                $LoggerApp "One recipient is not Accepted $whoError"
        ;;
        5)
                $LoggerApp "Remote do not accept data $whoError"
        ;;
        6)
                $LoggerApp "Unassigned $whoError"
        ;;
        7)
                $LoggerApp "Email is not accepted by remote $whoError"
        ;;
        *)
                $LoggerApp "Unknown error in clmsndr $whoError"
        ;;
        esac
        numMail='0'

return $Error
}
#----------------------------------------------
givedate ()

{
(
LANG=$formatLang date +"$formatDate "	
)|(
export  LANG=en_US.$LANG
iconv -t $LANG  -t ASCII//TRANSLIT;
)
}
#----------------------------------------------
print_mail_header ()
#$1 user
{
        echo "From: $senderExpire <"$FROM">" 
        echo "To: "$1,$2
        echo "$subjectExpire (`givedate`)"
        echo "Date: `date -R`"
}
#----------------------------------------------
print_header ()
#$1 recipient name
{
case "$DB_TYPE" in
  "POSTGRESQL"  )
  spe_user=`echo $1 | sed -e "s/'/''/" `
     ;;
  "MYSQL"       )
  spe_user=`echo $1 | sed -e 's/'\''/\\\\'\''/'`
     ;;
  esac
realname=`prob_db "SELECT realname FROM users WHERE username='$spe_user';"`
echo "$salutation $realname,"
echo ""
echo "$headerExpire $2 $headerExpire2 $3"
echo ""
}


#----------------------------------------------
print_core ()

{
echo "$bodyExpire"
}

#----------------------------------------------
print_email ()

{
CLEMSRVR=`prob_db "SELECT clemserver FROM clmgroup WHERE groupid=$2;"`
export FROM="Noreply@$CLEMSRVR"
upto=`prob_db "SELECT upto FROM clmgroup WHERE groupid=$2;"`
group=`prob_db "SELECT groupname FROM clmgroup WHERE groupid=$2;"`
superadmin=`prob_db "SELECT username FROM admin WHERE groupid=0 order by username;"`
#$1 user
langCheck $1
(
print_mail_header $1 $superadmin
#header separator
echo ""			
print_header $1 $group $upto
print_core
#print_footer
) | transmet $1 $superadmin
return $?
}

#----------------------------------------------
if [ -x $clmsndr ]; then
  (


  all_g=`prob_db "SELECT groupid from clmgroup;"`
  for grpid  in $all_g
    do
      grace=`prob_db "SELECT grace from clmgroup where groupid=$grpid;"`
      upto=`prob_db "SELECT upto from clmgroup where groupid=$grpid;"`
      NBD=`expr $NBDAY + $grace`
#  maxday=`date --date "$NBD days" '+%Y-%m-%d'`
  curday=`date '+%Y-%m-%d'`
#  curdayg=`date --date "$grace days" '+%Y-%m-%d'`

  up=`date '+%Y-%m-%d' -d "$upto $grace days"`  
  maxday=`date '+%Y-%m-%d' -d "$up 1 days"`  
  curdayg=`date '+%Y-%m-%d' -d "$up -$NBDAY days"`  
  grp=`prob_db "SELECT groupid from clmgroup where groupid=$grpid and '$up'>'$curdayg' and '$up'<'$maxday' and '$curday'>='$curdayg' ;"`
#  grp=`prob_db "SELECT groupid from clmgroup where groupid=$grpid and '$up'>'$curday' and '$up'<'$maxday' and '$curday'>'$curdayg';"`

   if [ -n "$grp" ] ; then
   all_admin=`prob_db "SELECT username FROM admin WHERE groupid=$grpid and (domain is null or domain='');"`
    if [ -z "$all_admin" ] ; then
      all_admin=`prob_db "SELECT username FROM admin WHERE groupid=0 order by username;"`
      fi
    for admin in $all_admin
      do
      print_email $admin $grpid
      Error=$?
      if [ $Error = '1' ]; then
        break
        fi
      done
      fi
    done
  )
else
  $LoggerApp "Error: Clement sender do not exist or is not accessible!!!"
  fi

