#! /bin/sh
#-----------------------------------------------------
#shell cript to generate clement.php from 
#data within clement.conf
#-----------------------------------------------------
#setting the basic definition
BASE=$1
. `dirname $0`/../shell/version.sh

#-----------------------------------------------------
#loading the variable value
. $BASE/etc/$APPNAME-$VERSION/$APPNAME.conf
#-----------------------------------------------------
#finish file
PHPFILE=$BASE/etc/$APPNAME-$VERSION/$APPNAME.php
#-----------------------------------------------------
#list of variable to extracte
SYSVAR="VERSION BASE CRYPT LANGUAGE CODE_CRYPT"
LDAP="LDAP_UID LDAP_EMAIL LDAP_ALTERNATE_EMAIL"
DBVAR="DB_TYPE DB_NAME DB_HOST DB_PORT"
ALLVAR="$SYSVAR $LDAP $DBVAR"
LINE="//----------------------------------------------------------------"
(
echo "<?php" 
echo "$LINE"
echo "//BEWARE:"
echo "//this file is generated from clement.conf contents, making change"
echo "//to that file will be lost at next \"service clement restart\"."
echo "$LINE"
for v in $ALLVAR
  do
  case "$v" in	
    "BASE"	)
       echo "//working base (usualy empty)"
       echo "\$base=\"${!v}\";"
       echo "putenv(\"base=\$base\");"
       ;;
    "DB_NAME"	)
       echo "//data-base name"
       if [ ! -n "${!v}" ]; then 
	   echo "\$dbname=\"clement\";"
       else
	   echo "\$dbname=\"${!v}\";"
       fi
       echo "putenv(\"dbname=\$dbname\");"
       ;;
    "DB_TYPE"	)
       echo "//data-base type "
       if [ ! -n "${!v}" ]; then 
	   echo "\$sqltype=\"POSTGRESQL\";"
       else
	   echo "\$sqltype=\"${!v}\";"
       fi
       echo "putenv(\"sqltype=\$sqltype\");"
       ;;
    "DB_HOST"	)
       echo "//data-base host "
       if [ ! -n "${!v}" ]; then 
	   echo "\$sqlhost=\"localhost\";"
       else
	   echo "\$sqlhost=\"${!v}\";"
       fi
       echo "putenv(\"sqlhost=\$sqlhost\");"
       ;;
    "DB_PORT"	)
       echo "//data-base port "
       if [ ! -n "${!v}" ]; then 
	   echo "\$sqlport=\"5432\";"
       else
	   echo "\$sqlport=\"${!v}\";"
       fi
       echo "putenv(\"sqlport=\$sqlport\");"
       ;;
    "VERSION"	)
       echo "//application version"
       echo "\$clemver=\"${APPNAME}-${!v}\";"
       echo "putenv(\"clemver=\$clemver\");"
       ;;
    "CRYPT"	)
       echo "//Default encoding password MD5 SHA512 SHA256 BLOWFISH"
       if [ ! -n "${!v}" ]; then 
	   echo "\$type_crypt=\"MD5\";"
       else
	   echo "\$type_crypt=\"${!v}\";"
       fi;
       echo "putenv(\"type_crypt=\$type_crypt\");"
       ;;
    "CODE_CRYPT"	)
       echo "//CODE_CRYPT ldaprootp "
       if [ ! -n "${!v}" ]; then 
	   echo "\$code_crypt=\" \";"
       else
	   echo "\$code_crypt=\"${!v}\";"
       fi
       echo "putenv(\"code_crypt=\$code_crypt\");"
       ;;
    "LDAP_UID"	)
       echo "//LDAP definitions "
       if [ ! -n "${!v}" ]; then 
	   echo "\$LDAP_UID=\"uid\";"
       else
	   echo "\$LDAP_UID=\"${!v}\";"
       fi
       echo "putenv(\"LDAP_UID=\$LDAP_UID\");"
       ;;
    "LDAP_EMAIL"	)
       if [ ! -n "${!v}" ]; then 
	   echo "\$LDAP_EMAIL=\"mail\";"
       else
	   echo "\$LDAP_EMAIL=\"${!v}\";"
       fi
       echo "putenv(\"LDAP_EMAIL=\$LDAP_EMAIL\");"
       ;;
    "LDAP_ALTERNATE_EMAIL"	)
       if [ ! -n "${!v}" ]; then 
	   echo "\$LDAP_ALTERNATE_EMAIL=\"mailAlternateAddress\";"
       else
	   echo "\$LDAP_ALTERNATE_EMAIL=\"${!v}\";"
       fi
       echo "putenv(\"LDAP_ALTERNATE_EMAIL=\$LDAP_ALTERNATE_EMAIL\");"
       ;;
    "LANGUAGE"	)
       echo "//Default working language"
       if [ ! -n "${!v}" ]; then 
	   echo "\$langbase=1;"
       else
	   if [ ${!v} != "English" ] ; then
	       echo "\$langbase=2;"
	   else
	       echo "\$langbase=1;"
	   fi
       fi
       echo "putenv(\"langbase=\$langbase\");"
       ;;
    *		)
	  echo "//------ERROR  $v not used in genphp.sh"
       ;;
    esac
echo "$LINE"
  done
echo "//extracting current username"
echo "exec(\"id -n -u\",\$MYID,\$retvalue);"
echo "\$dbusr=\$MYID[0];"
echo "putenv(\"dbusr=\$dbusr\");"
echo "//----------------------------------------------------------------"
echo "?>"
) > $PHPFILE
