#! /bin/sh
#-------------------------------------------------------------
#procedure to find out old email account and generate a list
#to be sent to domain postmaster
#this procedure detect the last time a user was reading its account
#-------------------------------------------------------------
#setting the basic definition
. `dirname $0`/../shell/version.sh
#-----------------------------------------------------
#loading the variable value
. $BASE/etc/$APPNAME-$VERSION/$APPNAME.conf
#-----------------------------------------------------
#HOWOLD is the maximun number of day without email reading
HOWOLD=180
#----------------------------------------------
#avoiding any race condition
LOCK=$BASE/var/lock/$APPNAME-$VERS/checkcount.lck
trap "rm -f $LOCK ; exit 1" 1 2 3 15
if [ -f $LOCK ] ; then
# the lock file already exists, so what to do?
  if [ "$(ps `cat $LOCK` | wc -l)" -gt 1 ]; then
    # process is still running
    echo "$0: quit at start: lingering process `cat $LOCK`"
    exit 1
  else
    # process not running, but lock file not deleted?
    echo " $0: orphan lock file warning. Lock file deleted."
    rm -f $LOCK
    fi
  fi
echo $$ > $LOCK
#----------------------------------------------
#positionning over the right directory
cd $BASE/var/spool/$APPNAME-$VERS/mails

#finding list of old account
for dom in `ls` ;						
  do							
  cd $dom ;
  find . -type d -mtime +$HOWOLD -name "cur"  		| 	\
    grep "dovecot/cur"					|	\
    ( while read -r dirname
        do
        ls -lsd $dirname 				|	\
        cut -d' ' -f7- | cut -d'/' -f1,2
        done
    ) | tr -s ' ' | sort -t ' ' -k 3n -k1,2M ;
    cd .. ;						
  done
#----------------------------------------------
#remove lock before exiting
rm -f $LOCK


