#! /bin/sh
#---------------------------------------------------------------
#procedure to update site data-base according upgrade version
#---------------------------------------------------------------
#Only one (optionnal) argument
#$1 base	;the testing base.
#---------------------------------------------------------------
#presetting previous version release
REL=0			
#setting the basic definition
if [ -f `dirname $0`/../shell/prev-version.sh ] ; then
  . `dirname $0`/../shell/prev-version.sh
  if [ -n "$UPDATE" ] ; then
    export OLDVERS=$VERSION.$LEVEL.$RELEASE-$UPDATE
  else
    export OLDVERS=$VERSION-$RELEASE
  fi
else 
  #setting RELNUM for clement-2.1
  RELNUM=21343
  fi
export PRVRELNUM=$RELNUM
#---------------------------------------------------------------
#loading the variable value
. `dirname $0`/../../../../etc/sysconfig/$APPNAME
. `dirname $0`/../shell/version.sh
export CURVERS=$VERSION-$RELEASE
#---------------------------------------------------------------
#Database setting
#first the Data-base type
if [ -z "$DB_TYPE" ] ; then
  DB_TYPE=POSTGRESQL;
  fi

#Then the data-base name
if [ -z "$DB_NAME" ] ; then
  DB_NAME=$APPNAME;
  fi
#setting data-base parameteres
case "$DB_TYPE" in
  "POSTGRESQL"  )
     export clemapache="apache"
     export clemdove="dovecot"
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-p $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     SQL="psql -t -q $SQLPOR $SQLHOST"
     ;;
  "MYSQL"       )
     export clemapache="apache@localhost"
     export clemdove="dovecot@localhost"
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-P $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     SQL="mysql -s -u root $SQLPOR $SQLHOST"
     ;;
  esac
#---------------------------------------------------------------
#setting log file
LOGFILE=$BASE/etc/$APPNAME-$VERS/dbinst.log
UTIL=`dirname $0`/../utilitities
#===============================================================
#procedure to upgrade to 2.5-148.002
upto_25148002()

{
(
echo "-- Adding imaptls authentification protocol"
echo "UPDATE clmgroup SET authproto='IMAPTLS' WHERE authproto='IMAP';"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-148.3
upto_25148003()

{
(
echo "-- Creating new table multipath;"
echo "CREATE TABLE multipath (i_email TEXT,e_email TEXT);"
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "CREATE UNIQUE INDEX multipath_ndx ON multipath (e_email);"
     ;;
  "MYSQL"  )
     echo "CREATE UNIQUE INDEX multipath_ndx ON multipath (e_email(40));"
     ;;
  esac
echo "GRANT SELECT,INSERT,UPDATE,DELETE ON multipath TO $clemapache;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-148.6
upto_25148006()

{
(
echo "-- Adding email MSG-ID within emlog;"
echo "ALTER TABLE emlogs ADD COLUMN msgid TEXT;"
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "CREATE INDEX emlogs_msgid ON emlogs (msgid);"
     ;;
  "MYSQL"  )
     echo "CREATE INDEX emlogs_msgid ON emlogs (msgid(80));"
     ;;
  esac
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-148.9
upto_25148009()

{
(
echo "-- removing bl.ipv6.spameatingmonkey.net from blshosts list"
echo "DELETE FROM blshosts WHERE blsserver='bl.ipv6.spameatingmonkey.net';"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.6-0.0
upto_26000000000()

{
(
echo "-- Updating cron to new version $VERSION"
echo "UPDATE cron SET cmd='/usr/lib/clement-2.6/support/sendquarlist.sh' WHERE cmd='/usr/lib/clement-2.5/support/sendquarlist.sh';"
echo "-- Adjusting clmgroup table"
echo "ALTER TABLE clmgroup ADD COLUMN ldapbase TEXT;"
echo "ALTER TABLE clmgroup ADD COLUMN ldaprootdn TEXT;"
echo "-- Adjusting users table"
echo "ALTER TABLE users ADD COLUMN nummsgs INTEGER;"
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "ALTER TABLE clmgroup ADD COLUMN ldaprootp BYTEA;"
     echo "ALTER TABLE users ALTER COLUMN nummsgs SET DEFAULT 0;"
     echo "ALTER TABLE users RENAME usedmgbytes TO usedbytes;"
     echo "ALTER TABLE users ALTER COLUMN usedbytes TYPE BIGINT;"
     echo "-- Updating role priviledge to new version $VERSION"
     ;;
  "MYSQL"  )
     echo "ALTER TABLE clmgroup ADD COLUMN ldaprootp MEDIUMBLOB;"
     echo "GRANT USAGE ON $DB_NAME.* TO $clemdove;"
     echo "ALTER TABLE users CHANGE nummsgs nummsgs INTEGER DEFAULT 0;"
     echo "ALTER TABLE users CHANGE usedmgbytes usedbytes BIGINT;"
     ;;
  esac
echo "UPDATE users SET nummsgs=0;"
echo "UPDATE users SET usedbytes=usedbytes*(1024*1024);"
echo "ALTER TABLE clmgroup ADD COLUMN maxusergr INTEGER DEFAULT 0;"
echo "ALTER TABLE clearance ADD COLUMN ip TEXT;"
echo "-- Updating access priviledge to userprofile table to dovecot;"
echo "GRANT UPDATE ON users TO $clemdove;"
echo "GRANT SELECT ON userprofile TO $clemdove;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.6-2.0
upto_26002001000()

{
(
echo "-- Removing dnsbl.njabl.org from the BLS list;"
echo "DELETE FROM blshosts WHERE blsserver='dnsbl.njabl.org';"
echo "-- Adding piped status to filterinfo;"
echo "UPDATE filterinfo SET code=22 WHERE code=21;"
echo "INSERT INTO filterinfo (type, code, lang, color, str, description, bgcolor)"
echo "          VALUES (1,21,1,'black','Piped','Mail has been piped to a shell script','#66FFFF');"
echo "INSERT INTO filterinfo (type, code, lang, color, str, description, bgcolor)"
echo "          VALUES (1,21,2,'black','Canalis&eacute;','Courrier canalis&eacute pour traitement','#66FFFF');"
echo "-- Updating Logs;"
echo "UPDATE emlogs set status=22 where status=21;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#===============================================================
#---------------------------------------------------------------
#Main process
#---------------------------------------------------------------
(
echo "#-------------------------------------------"
echo "#On" `date`
echo "#version Database upgrade from $OLDVERS to $CURVERS"
if [ $PRVRELNUM -lt 25148003 ] ; then
  upto_25148003
  fi
if [ $PRVRELNUM -lt 25148006 ] ; then
  upto_25148006
  fi
if [ $PRVRELNUM -lt 25148009 ] ; then
  upto_25148009
  fi
if [ $PRVRELNUM -lt 26000000000 ] ; then
  upto_26000000000
  fi
if [ $PRVRELNUM -lt 26002001000 ] ; then
  upto_26002001000
  fi
) >> $LOGFILE 2>&1
