#! /bin/sh
#---------------------------------------------------------------
#procedure to update site data-base according upgrade version
#---------------------------------------------------------------
#Only one (optionnal) argument
#$1 base	;the testing base.
#---------------------------------------------------------------
#presetting previous version release
REL=0			
#setting the basic definition
if [ -f `dirname $0`/../shell/prev-version.sh ] ; then
  . `dirname $0`/../shell/prev-version.sh
  if [ -n "$UPDATE" ] ; then
    export OLDVERS=$VERSION.$LEVEL.$RELEASE-$UPDATE
  else
    export OLDVERS=$VERSION-$RELEASE
  fi
else 
  #setting RELNUM for clement-2.1
  RELNUM=21343
fi
export PRVRELNUM=$RELNUM
#---------------------------------------------------------------
#loading the variable value
. `dirname $0`/../../../../etc/sysconfig/$APPNAME
. `dirname $0`/../shell/version.sh
export CURVERS=$VERSION-$RELEASE
#---------------------------------------------------------------
#Database setting
#first the Data-base type
if [ -z "$DB_TYPE" ] ; then
  DB_TYPE=POSTGRESQL;
  fi

#Then the data-base name
if [ -z "$DB_NAME" ] ; then
  DB_NAME=$APPNAME;
  fi
#setting data-base parameteres
case "$DB_TYPE" in
  "POSTGRESQL"  )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-p $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     SQL="psql -q $SQLPOR $SQLHOST"
     ;;
  "MYSQL"       )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-P $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     SQL="mysql -u root $SQLPOR $SQLHOST"
     ;;
  esac
#---------------------------------------------------------------
#setting log file
LOGFILE=$BASE/etc/$APPNAME-$VERSION/dbinst.log
UTIL=`dirname $0`/../utilitities
#===============================================================
#procedure to upgrade to 2.6-0.0
#===============================================================
upto_26000000000()

{
(							
echo "Updating httpd and dovecot $APPNAME configuration file"
/etc/init.d/httpd stop
/etc/init.d/dovecot stop
echo "Updating dovecot symbolic link"
cd /etc/dovecot ; 
ln -nsf /etc/$APPNAME-$VERSION/dovecot-2.0.conf	dovecot.conf
echo "Changing $APPNAME home directory"
/usr/sbin/usermod -d /var/spool/$APPNAME-$VERSION $APPNAME
sleep 5	#waiting httpd shutdown
/bin/sed	 						\
	-i							\
	-e "s/$APPNAME-2.5/$APPNAME-$VERSION/"			\
 	/etc/httpd/conf.d/$APPNAME.conf
sed -i -e "s/TO_BE_DEFINED/$DB_TYPE/" $BASE/etc/$APPNAME-$VERSION/$APPNAME.conf
ln -nsf $BASE/etc/$APPNAME-$VERSION/dovecot-dict-$DB_TYPE.conf.ext $BASE/etc/$APPNAME-$VERSION/dovecot-dict-sql.conf.ext
case "$DB_TYPE" in
  "POSTGRESQL"	)
    sed -i -e "s/sqlquota=dbsql/sqlquota=pgsql/" $BASE/etc/$APPNAME-$VERSION/dovecot-2.0.conf
    echo "ALTER ROLE $APPNAME WITH SUPERUSER;" | $PSQL $APPNAME
    cat /usr/share/pgsql/contrib/pgcrypto.sql | $PSQL $APPNAME
    ;;
  "MYSQL"	)
    sed -i -e "s/sqlquota=dbsql/sqlquota=mysql/" $BASE/etc/$APPNAME-$VERSION/dovecot-2.0.conf
    ;;
  esac
(
case "$DB_TYPE" in 
  "POSTGRESQL"	)
    echo "driver = pgsql"
    echo "connect=  dbname=$APPNAME"
    echo "password_query=SELECT password,'Y' AS nopassword FROM users WHERE username='%u'"
    echo "user_query=SELECT 'clement' AS uid,'mail' AS gid,'/var/spool/clement-2.6/mails/%d/%n' AS home,'maildir:~/dovecot' AS mail,'*:storage='||mxmgbytes||'M' AS quota_rule FROM userprofile WHERE prfid=(SELECT prfid FROM users WHERE username='%u')"
    ;;
  "MYSQL"	)
    echo "driver = mysql"
    echo "connect= host=localhost dbname=$APPNAME"
    echo "password_query=SELECT password,'Y' AS nopassword FROM users WHERE username='%u'"
    echo "user_query=SELECT 'clement' AS uid,'mail' AS gid,'/var/spool/clement-2.6/mails/try1.safe.ca/root' AS home,'maildir:~/dovecot' AS mail,concat('*:storage=',mxmgbytes,'M') AS quota_rule from userprofile WHERE prfid=(SELECT prfid FROM users WHERE username='%u')"
    ;;
  esac
) >> $BASE/etc/$APPNAME-$VERSION/dovecot-sql.conf
cat  $BASE/etc/$APPNAME-$VERS/dovecot-2.0-auth-sql.conf >> $BASE/etc/$APPNAME-$VERSION/dovecot-2.0.conf
/etc/init.d/httpd start
/etc/init.d/dovecot start
)
}
#---------------------------------------------------------------
#---------------------------------------------------------------
#Main process
#---------------------------------------------------------------
#make sure the log file existing and own by application
touch $LOGFILE
chown $APPNAME.mail $LOGFILE
(
echo "#-------------------------------------------"
echo "#On" `date`
echo "#version files upgrade from $OLDVERS to $CURVERS"
if [ $PRVRELNUM -lt 26000000000 ] ; then
  upto_26000000000
  fi
) >> $LOGFILE 2>&1
(
echo "#==========================================="
echo "Removing /var/crash/$APPNAME-$VERSION.$LEVEL core dump file"
rm -fr /var/crash/$APPNAME-$VERSION.$LEVEL/core.*
echo "#==========================================="
) >> $LOGFILE
